# nacteme matematickou a numerickou knihovnu
import math
import numpy as np

# kolik bodu budeme generovat
pocet = 1000000
# pole (matice) nahodnych cisel od 0 do 1,
# ktera ma "pocet" radku a 2 sloupce, pricemz kazdy
# radek predstavuje souradnice x a y jednoho bodu
n = np.random.rand(pocet,2)
# souradnici x preskalujeme na interval od nula do pi
n[:,0] *= math.pi
# inicializace promenne, do niz budeme ukladat pocet zasahu
pocet_uvnitr = 0

# cyklus, ktery prochazi cisla od 0 do pocet-1
for i in range(0,pocet):
    # v hranate zavorce piseme radkovy a sloupcovy index oddeleny carkou,
    # pomoci podminky kontrolujeme, ze bod lezi pod krivkou kvadratu sinu
    if n[i,1] < (math.sin(n[i,0]))**2:
        # pokud je podminka splnena, zvysime pocet zasahu o jedna
        pocet_uvnitr += 1

# vypocet prumeru; ve jmenovateli je prictena nula, aby byl vysledek float
box = math.pi
prumer = pocet_uvnitr/(pocet+0.)*box
# relativni odchylka od prumeru a relativni smerodatna odchylka
# math.pi vola hodnotu cisla pi
vysledek = math.pi/2.                 
odchylka = np.abs(prumer - vysledek)/vysledek
smodch = np.sqrt(vysledek*(box - vysledek)/pocet)/vysledek

# nechame vypsat vysledek na obrazovku
print("Prumer: {}, relativni smodch: {}, relativni odchylka od prumeru: {}.".format(prumer, smodch, odchylka))
